JSB.require('utils');
JSB.require('CryptoJS')
JSB.require('network')
JSB.require('marked')
// JSB.require('base64')
/** @return {notificationController} */
const getNotificationController = ()=>self


var notificationController = JSB.defineClass('notificationController : UIViewController <NSURLConnectionDelegate>', {
  viewDidLoad: function() {
    let self = getNotificationController()
    self.init()
    self.appInstance = Application.sharedInstance();
    self.custom = false;
    self.customMode = "None"
    // Application.sharedInstance().showHUD("process:0",Application.sharedInstance().focusWindow,5)
    self.dynamic = true;
    self.markdown = true
    self.miniMode = false;
    self.shouldCopy = false
    self.shouldComment = false
    self.selectedText = '';
    self.searchedText = '';
    self.isLoading = false;
    self.toolbarOn = true;
    self.view.frame = {x:50,y:50,width:(self.appInstance.osType !== 1) ? 419 : 365,height:120}
    self.lastFrame = self.view.frame;
    // self.currentFrame = self.view.frame
    self.history = []
    self.isMainWindow = true
    self.title = "main"
    self.test = [0]
    self.moveDate = Date.now()
    self.notifyLoc = self.config.notifyLoc
    self.color = [true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true]
    self.view.layer.shadowOffset = {width: 0, height: 0};
    self.view.layer.shadowRadius = 15;
    self.view.layer.shadowOpacity = 0.5;
    self.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
    self.view.layer.cornerRadius = 11
    self.view.layer.opacity = 1.0
    self.view.layer.borderColor = hexColorAlpha("#9bb2d6",0.8)
    self.view.layer.borderWidth = 0
    self.view.backgroundColor = hexColorAlpha("#ffffff",0)

    self.highlightColor = UIColor.blendedColor( hexColorAlpha("#2c4d81",0.8),
      self.appInstance.defaultTextColor,
      0.8
    );

try {
  

    self.notificationView = UIView.new()
    self.notificationView.layer.cornerRadius = 8
    self.notificationView.backgroundColor = hexColorAlpha("#ffffff",0.0)
    self.view.addSubview(self.notificationView)
    self.notiScroll = UIScrollView.new()
    self.notiScroll.layer.cornerRadius = 8
    self.notiScroll.backgroundColor = hexColorAlpha("#ffffff",0.0)
    self.notiScroll.scrollEnabled = true

    self.notificationView.addSubview(self.notiScroll)
    if (self.markdown) {
      self.createWebviewResponse()
      self.notificationView.addSubview(self.webviewResponse)
    }else{
      self.createTextviewResponse()
      self.notiScroll.addSubview(self.textviewResponse)
    }

    self.createButton("toolbar",undefined,"notificationView")
    self.toolbar.backgroundColor = hexColorAlpha("#727f94",0.0)

    // self.createButton("screenButton","changeScreen:","toolbar")
    self.createButton("screenButton","closeButtonTapped:","toolbar")
    self.screenButton.setImageForState(self.stopImage,0)
    self.screenButton.backgroundColor = hexColorAlpha("#e06c75",0.8)

    self.createButton("bigbangButton","bigbang:","toolbar")
    self.bigbangButton.setImageForState(self.bigbangImage,0)

    self.createButton("copyButton","copy:","toolbar")
    self.copyButton.setImageForState(self.copyImage,0)

    self.createButton("titleButton","setNoteTitle:","toolbar")
    self.titleButton.setImageForState(self.titleImage,0)

    self.createButton("commentButton","setComment:","toolbar")
    self.commentButton.setImageForState(self.commentImage,0)

    self.createButton("promptButton","changePrompts:","toolbar")
    self.promptButton.setTitleForState("关键词",0)
    self.promptButton.titleLabel.font = UIFont.boldSystemFontOfSize(16);

    self.createButton("locationButton","toggleLocation:","toolbar")
    self.locationButton.setTitleForState(self.config.notifyLoc?' R ':' L ',0)
    // self.locationButton.setTitleForState(" R ")
    self.locationButton.titleLabel.font = UIFont.boldSystemFontOfSize(20);

    self.createButton("aiLinkButton","showAILink:","toolbar")
    self.aiLinkButton.setImageForState(self.aiLinkImage,0)

    self.createButton("reloadButton","reAsk:","toolbar")
    self.reloadButton.setImageForState(self.reloadImage,0)

    self.createButton("chatButton","openChatView:","toolbar")
    self.chatButton.setImageForState(self.chatImage,0)

    self.createButton("aiButton")
    self.aiButton.setImageForState(self.aiImage,0)
    self.aiButton.backgroundColor = hexColorAlpha("#ffffff",0.8)

    // self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    // self.screenButton.addGestureRecognizer(self.resizeGesture)
    // self.resizeGesture.view.hidden = false
    // self.resizeGesture.addTargetAction(self,"onResizeGesture:")
} catch (error) {
  showHUD(error)
}
  },
  viewWillAppear: function(animated) {
  },
  viewWillDisappear: function(animated) {
  },
  viewWillLayoutSubviews: function() {
  let self = getNotificationController()
    // Application.sharedInstance().showHUD("test", self.view.window, 2);
    // Application.sharedInstance().showHUD("process:5",Application.sharedInstance().focusWindow,5)
// showHUD("udpate")
    let buttonHeight = 30
    // self.view.frame = self.currentFrame
    var viewFrame = self.view.frame;
    var height   = viewFrame.height

    if (self.onChat) {
      // let studyFrame = studyController().view.frame
      // viewFrame.height = studyFrame.height-50
      // self.view.frame = viewFrame
      // self.currentFrame = viewFrame
      // viewFrame.x = 0
      // viewFrame.y = 0
      // self.chatView.frame = viewFrame
      // self.setChatLayout()
    }else{
      viewFrame.x = 0
      viewFrame.y = 0
      self.notificationView.frame = viewFrame;
      viewFrame.width = 400
      viewFrame.height = height-35
      self.notiScroll.frame = viewFrame

      if (self.markdown) {
        self.webviewResponse.frame = viewFrame
      }else{
        viewFrame.height = self.textviewResponse.sizeThatFits({width:400,height:1000}).height
        if (viewFrame.height<120) {
          viewFrame.height = 120
        }
        self.textviewResponse.frame = viewFrame
      }
      // showHUD("contentHeight:"+viewFrame.height+";viewHeight:"+self.textviewResponse.frame.height)
      self.toolbar.frame = genFrame(0, height-30, 400,buttonHeight)
      self.setLayout()
    }

  },
  closeButtonTapped:async function (params) {
  try {
    

    let self = getNotificationController()
    if (self.connection) {
      self.connection.cancel()
      delete self.connection
    }
    await self.hide()
    self.onChat = false
    if (self.chatView) {
      self.chatView.hidden = true
    }
    self.notificationView.hidden = false
    if (self.markdown) {
      self.webviewResponse.frame = genFrame(0, 0, 400, 85)
      self.sizeHeight = parseInt(await self.runJavaScript(`document.body.scrollHeight`))
    }else{
      self.textviewResponse.frame = genFrame(0, 0, 400, 120)
    }
    // showHUD("message"+self.sizeHeight)
      } catch (error) {
    showHUD(error)
  }
  },
  bigbang:async function () {
    // showHUD("noteid"+self.noteid)
    let text = await self.getTextForAction()
    if (!self.noteid) {
      postNotification("bigbangText",{text:text})
    }else{
      postNotification("bigbangText",{text:text,noteid:self.noteid,url:"marginnote3app://note/"+self.noteid})
    }
  },
  copy: async function (sender) {
  try {
    let self = getNotificationController()
    let text = await self.getTextForAction()
    showHUD("文字已复制")
    if (sender.clickDate && Date.now()-sender.clickDate < 500) {
      if (/^".*"$/.test(text)) {
        let length = text.length
          text = text.slice(1,length-1)
      }
    }else{
      sender.clickDate = Date.now()
    }
    UIPasteboard.generalPasteboard().string = text
  } catch (error) {
    showHUD(error)
  }
  },
  // textViewDidBeginEditing:function (textview) {
  //   self.notifyTimer.invalidate()
  // },
  reAsk:function (params) {
    let self = getNotificationController()
    try {
      
    if (self.notifyTimer) {
      self.notifyTimer.invalidate()
    }
    self.notShow = false
    self.called = true
    self.ask(self.question,1.0)
    } catch (error) {
      showHUD(error)
    }
  },
  setNoteTitle: async function(sender) {
    if (!self.noteid) {
      showHUD("Unavailable")
    }
    let text = await self.getTextForAction()
    let note = getNoteById(self.noteid)
    if (sender.clickDate && Date.now()-sender.clickDate < 500) {
      if (/^".*"$/.test(text)) {
        let length = text.length
        undoGroupingWithRefresh(self.notebookid,()=>{
          note.noteTitle = text.slice(1,length-1)
        })
      }
    }else{
      sender.clickDate = Date.now()
      undoGroupingWithRefresh(self.notebookid,()=>{
        note.noteTitle = text
      })
    }
    // try {
      
    // }catch (error) {
    //   showHUD(error)
    // }
  },
  setComment: async function () {
    if (!self.noteid) {
      showHUD("Unavailable")
    }
    let text = await self.getTextForAction()
    let note = getNoteById(self.noteid)
    undoGroupingWithRefresh(self.notebookid,()=>{
      note.appendTextComment(text.trim())
    })
  },
  showAILink: async function () {
    if (!self.noteid) {
      showHUD("Unavailable")
    }
    let text = await self.getTextForAction()
    postNotification("aiLinkOnText",{text:text,noteid:self.noteid})
  },
  changePrompts: function(sender) {
    let self = getNotificationController();
    self.promptButton.setTitleForState(self.addonController.prompts[self.currentPrompt].title ,0)
    var commandTable = self.config.promptNames.map(promptName => {
      return {title:self.addonController.prompts[promptName].title,object:self,selector:'askWithPrompt:',param:promptName,checked:self.config.currentPrompt===promptName}
    })
    self.view.popoverController = getPopoverAndPresent(sender,commandTable,200)
  },
  askWithPrompt: function (prompt) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    try {
    let self = getNotificationController();
    let question = self.addonController.getQuestion(self.text,prompt)
    self.ask(question)
    self.currentPrompt = prompt
    self.promptButton.setTitleForState(self.addonController.prompts[prompt].title ,0)
      
    } catch (error) {
      showHUD(error)
    }
  },
  onResizeGesture:function (gesture) {
    if (self.notifyTimer) {self.notifyTimer.invalidate()}
    if (self.notifyLoc === 0) {
      self.custom = false;
      self.dynamic = false;
      self.customMode = "none"
      let baseframe = gesture.view.frame
      let locationToBrowser = gesture.locationInView(self.view)
      let frame = self.view.frame
      let height = locationToBrowser.y+baseframe.height*0.5
      if (height <= 100) {
        height = 100
      }
      //  Application.sharedInstance().showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
      //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
      self.view.frame = {x:50,y:50,width:400,height:height}
      self.currentFrame  = self.view.frame
    }else{
      self.custom = false;
      self.dynamic = false;
      self.customMode = "none"
      let baseframe = gesture.view.frame
      let locationToBrowser = gesture.locationInView(self.view)
      let frame = self.view.frame
      let height = locationToBrowser.y+baseframe.height*0.5
      if (height <= 120) {
        height = 120
      }
      //  Application.sharedInstance().showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
      //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
      self.view.frame = {x:frame.x,y:50,width:400,height:height}
      self.currentFrame  = self.view.frame
    }

  },
  toggleLocation:function (params) {
    let self = getNotificationController()
    // showHUD("show:"+self.addonController.config.notifyLoc)
    try {
    switch (self.addonController.config.notifyLoc) {
      case 1:
        self.addonController.config.notifyLoc = 0
        if (self.onChat) {
          self.chatLocation.setTitleForState("Left",0)
          self.setChatLayout()
        }else{
          self.locationButton.setTitleForState(" L ",0)
        }
        if (self.addonController.windowLocationButton) {
          self.addonController.windowLocationButton.setTitleForState("Notification: Left",0)
        }
        break;
      case 0:
        self.addonController.config.notifyLoc = 1
        if (self.onChat) {
          self.chatLocation.setTitleForState("Right",0)
          self.setChatLayout()
        }else{
          self.locationButton.setTitleForState(" R ",0)
        }
        if (self.addonController.windowLocationButton) {
          self.addonController.windowLocationButton.setTitleForState("Notification: Right",0)
        }
        // self.locationButton.setTitleForState(" R ",0)
        break;
      default:
        break;
    }
    self.show(self.addonController.config.notifyLoc)
    
    // self.notifyController.config = self.config
    setLocalDataByKey(self.addonController.config,'MNChatglm_config')
    } catch (error) {
      showHUD(error)
    }
  },
  openChatView: function (params) {
    let self = getNotificationController()
    if (self.connection) {
      showHUD("Wait...")
      return
    }
    try {
      

    self.round = 0
    if (self.notifyTimer) {
      self.notifyTimer.invalidate()
    }
    self.notificationView.hidden = true
    self.onChat = true
    // self.openChatView()
    self.chatView = new UIView(self.view.bounds)
    self.chatView.layer.cornerRadius = 8
    self.chatView.backgroundColor = hexColorAlpha("#ffffff",0.0)
    self.view.addSubview(self.chatView)
    self.chatToolbar = UIView.new()
    self.chatToolbar.layer.cornerRadius = 8
    self.chatToolbar.backgroundColor = hexColorAlpha("#ffffff",0.0)
    self.chatView.addSubview(self.chatToolbar)
    self.createButton("closeChatButton","closeButtonTapped:","chatToolbar")
    self.closeChatButton.setImageForState(self.stopImage,0)
    self.closeChatButton.backgroundColor = hexColorAlpha("#e06c75",0.8)
    self.createButton("sendButton","continueAsk:","chatView")
    self.sendButton.setImageForState(self.sendImage,0)
    self.sendButton.backgroundColor = hexColorAlpha("#e06c75",0.8)
    self.creatTextView("userInput","chatView")
    self.userInput.editable = true
    self.userInput.layer.borderColor = hexColorAlpha("#9bb2d6",0.8)
    self.createButton("chatLocation","toggleLocation:","chatToolbar")
    self.chatLocation.setTitleForState(self.config.notifyLoc?'Right':'Left',0)
    self.chatLocation.titleLabel.font = UIFont.boldSystemFontOfSize(16);
    self.createButton("chatToken","doNothing:","chatToolbar")
    if (self.addonController.config.source === "ChatGLM") {
      self.chatToken.hidden = false
      self.chatToken.setTitleForState(self.token[0]+"("+sum(self.token)+")",0)
      self.chatToken.titleLabel.font = UIFont.boldSystemFontOfSize(16);
    }else{
      self.chatToken.hidden = true
    }
    self.scrollView = UIScrollView.new()
    self.scrollView.layer.cornerRadius = 8
    self.scrollView.backgroundColor = hexColorAlpha("#ffffff",0.8)
    self.chatView.addSubview(self.scrollView)
    self.creatTextView("assistant0","scrollView")
    if (self.markdown) {
      self.assistant0.text = self.response
    }else{
      self.assistant0.text = self.textviewResponse.text
    }
    self.assistant0.layer.borderColor = hexColorAlpha("#ffffff",0.8)
    var viewFrame = self.view.frame;
    var height   = viewFrame.height
    let studyFrame = studyController().view.frame
    viewFrame.height = studyFrame.height-50
    self.view.frame = viewFrame
    self.currentFrame = viewFrame
    self.chatView.frame = genFrame(0, 0, viewFrame.width, viewFrame.height)
    self.setChatLayout()
    // let controller = self
    NSTimer.scheduledTimerWithTimeInterval(0.1, false, function () {
      let size = self.assistant0.sizeThatFits({width:viewFrame.width-10,height:1000})
      self.assistant0.frame = genFrame(5,5, viewFrame.width-10, size.height)
    })
    } catch (error) {
      showHUD(error)
    }
  },
  continueAsk: function (params) {
    let self = getNotificationController()
    if (self.connection) {
      showHUD("Wait...")
      return
    }
    self.round = self.round+1
    try {
      
    let text = self.userInput.text
    self.userInput.text = ""
    self.creatTextView("user"+self.round,"scrollView")
    self["user"+self.round].text = text
    self["user"+self.round].layer.borderColor = hexColorAlpha("#9bb2d6",0.8)
    self["user"+self.round].backgroundColor = hexColorAlpha("#9bb2d6",0.2)
    self.creatTextView("assistant"+self.round,"scrollView")
    self["assistant"+self.round].text = "I'm thinking..."
    self["assistant"+self.round].layer.borderColor = hexColorAlpha("#ffffff",0.8)
    self.targetTextview = "assistant"+self.round
    self.setChatLayout()
    self.continueAsk(text)
    } catch (error) {
      showHUD(error)
    }
    // showHUD("continue")
  },
  textViewDidBeginEditing:function (textview) {
    // showHUD("begin")
    self.notifyTimer.invalidate()
  },
  connectionDidReceiveResponse: async function (connection,response) {
    let self = getNotificationController()
    // let res = new Response(response)
    // showHUD(JSON.stringify(res))
    // copy(JSON.stringify(res))
    // showHUD("response")
    self.response = ""
    self.originalText = ""
    self.source = self.addonController.config.source
    // showHUD("delay:"+Date.now()-self.currentTime)
    // if (self.notShow && !self.called) {
    //   // showHUD("not")
    //   connection.cancel()
    //   delete self.connection
    //   return
    // }
    self.notShow = false
    self.size = []
    self.preHeight = 0
    self.autoHide = true
    self.sizeHeight = 0
    self.scrollToBottom = false

    if (self.onChat) {
      self.setChatLayout()
      // return
    }else{
      // self.webviewResponse.loadHTMLStringBaseURL(html("test"))
      self.sizeHeight = parseInt(await self.runJavaScript(`document.body.scrollHeight`))
      self.setNotiLayout()
    }
    self.bigbangButton.layer.opacity = 0.5
    self.commentButton.layer.opacity = 0.5
    self.copyButton.layer.opacity = 0.5
    self.titleButton.layer.opacity = 0.5
    self.locationButton.layer.opacity = 0.5
    self.promptButton.layer.opacity = 0.5
    self.chatButton.layer.opacity = 0.5
    self.reloadButton.layer.opacity = 0.5
    self.aiLinkButton.layer.opacity = 0.5
    // let currentFrame = self.view.frame
    // currentFrame.height = 120
    // self.view.frame = currentFrame
    // self.beginNotification()
    // self.allText = ""
  },

  connectionDidReceiveData: async function (connection,data) {
    // showHUD("data")

    let self = getNotificationController()
    try {
      

    let test = CryptoJS.enc.Base64.parse(data.base64Encoding())
    self.textString = CryptoJS.enc.Utf8.stringify(test);
    // copy(self.textString)
    if (!/data:/.test(self.textString) && self.textString.trim() !=="") {
      if (/chat\.completion\.chunk/.test(self.textString)) {
        return
      }
      showHUD(self.textString)
      // copy(self.textString)
      return;
    }
    } catch (error) {
      showHUD(error)
    }
    // let jsonText = JSON.parse(self.textString)
    // copy(JSON.stringify(jsonText.choices[0].message.content))
    self.getResponseForChatGPT(self.textString)
    await self.setResponseText(self.response)

    // }else{
    //   return
    // }
    // var checkMessageNumber = self.textString.split("event:add")
    // let messageBumber = checkMessageNumber.length
    // if (messageBumber>=2) {
    //   var items = checkMessageNumber[messageBumber-1].split("\n")
    //   let data
    //   if (items.length !== 5) {
    //     let dataItems = items.filter(item=>/data:/.test(item))
    //     // showHUD(dataItems)
    //     data = dataItems.map(item=>item.split("data:")[1]).join("\n")
    //   }else{
    //     data = items[2].split("data:")[1]
    //   }
    //   // self.response = self.response+data
    //   // self.allText = self.allText+textString
    //   let diff = data.length - self[self.targetTextview].text.length
    //   if (diff > 30 || diff < 0) {
    //     return
    //   }
    //   self[self.targetTextview].text = data.trim()//self.response.trim().replaceAll("   ","\n").replaceAll("  "," ")
    //   // self[self.targetTextview].scrollRectToVisibleAnimated(genFrame(0, size.height-currentFrame.height, 400, currentFrame.height-30),false)
    // }else{
    //   return
    // }
    if (self.onChat) {
      self.setChatLayout()
      // return
    }else{
      self.setNotiLayout()
    }
    return
  },
  connectionDidFinishLoading: function (connection) {
  let self = getNotificationController()
  // showHUD("finish")
  // copy(marked.parse(self.response))
  self.scrollToBottom = false
  if (self.addonController.config.source === "ChatGLM") {
    
    if (/event\:interrupted/.test(self.textString)) {
      let data = self.textString.split("data:").at(-1)
      // showHUD(data)
      self.finish()
      return;
    }
  try {
    let tokens = self.textString.split(`event:finish`)[1].split(`"total_tokens":`)
    let token = tokens[1].split("}")[0]
    var items = self.textString.split(`event:finish`)[1].split("\n")
    self.token.push(Number(token))
    if (self.onChat) {
      if (self.addonController.config.source === "ChatGLM") {
        self.chatToken.setTitleForState(""+token+" ("+sum(self.token)+")",0)
      }
    }else{
      self.promptButton.setTitleForState(token,0)
    }
    let data
    if (items.length !== 5) {
      let dataItems = items.filter(item=>/data:/.test(item))
      // showHUD(dataItems)
      data = dataItems.map(item=>item.split("data:")[1]).join("\n")
    }else{
      data = items[2].split("data:")[1]
    }
    self.setResponseText(data.trim())
    // self[self.targetTextview].text = data.trim()//self.response.trim().replaceAll("   ","\n").replaceAll("  "," ")
  } catch (error) {
    // copy(self.textString)
    let tokens = self.textString.split(`"total_tokens":`)
    let token = tokens[1].split("}")[0]
    self.token.push(Number(token))
    if (self.onChat) {
      // self.chatLocation.setTitleForState(token,0)
      if (self.addonController.config.source === "ChatGLM") {
        self.chatToken.setTitleForState(""+token+" ("+sum(self.token)+")",0)
      }
    }else{
      self.promptButton.setTitleForState(token,0)
    }
  }
  }
  try {
    if (self.onChat) {
      self.setChatLayout()
    }else{
      self.setNotiLayout()
    }
    self.finish()
  } catch (error) {
    showHUD(error)
  }
  self.bigbangButton.layer.opacity = 1.0
  self.commentButton.layer.opacity = 1.0
  self.copyButton.layer.opacity = 1.0
  self.titleButton.layer.opacity = 1.0
  self.locationButton.layer.opacity = 1.0
  self.promptButton.layer.opacity = 1.0
  self.chatButton.layer.opacity = 1.0
  self.reloadButton.layer.opacity = 1.0
  self.aiLinkButton.layer.opacity = 1.0
    // UIPasteboard.generalPasteboard().string = self.allText
  },
  connectionDidFailWithError: function (connection,error) {
    showHUD("error")
    self.bigbangButton.layer.opacity = 1.0
    self.commentButton.layer.opacity = 1.0
    self.copyButton.layer.opacity = 1.0
    self.titleButton.layer.opacity = 1.0
    self.locationButton.layer.opacity = 1.0
    self.promptButton.layer.opacity = 1.0
    self.chatButton.layer.opacity = 1.0
    self.reloadButton.layer.opacity = 1.0
    self.aiLinkButton.layer.opacity = 1.0
  }
});

notificationController.prototype.preCheck = function () {
  if (this.connection) {
    showHUD("on output")
    return false
  }
  if (this.notShow && !this.called) {
    // showHUD("not show")
    return false
  }
  if (this.addonController.config.source === "Built-in") {
    let usage = getUsage()
    if (usage.usage >= usage.limit) {
      showHUD("Access limited")
      return false
    }else{
      usage.usage = usage.usage+1
      // showHUD("usage:"+usage.usage)
      setLocalDataByKey(usage,'MNChatglm_usage')
    }
    if (this.addonController.usageButton) {
      this.addonController.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
    }
  }
  return true
}
/**
 * 
 * @param {*} question 
 * @param {*} temperature 
 * @param {*} reask 
 * @this {notificationController}
 */
notificationController.prototype.ask = async function(question,temperature=0.8,reask=false) {
try {
  
  // Application.sharedInstance().showHUD(url, this.view.window, 2);
  // showHUD("delay:"+this.config.delay)
  // if (!this.response) {
  //   this.response = ""
  // }
  // this.response = this.response+"time:"+Date.now()
  // copy(this.response)
  this.history = []
  this.token = []
  this.targetTextview = "textviewResponse"
  let config = this.addonController.config
  /**
   * @type {notificationController}
   */
  // let controller = this
  let delay = config.delay
  if (this.called) {
    delay = 0
  }
  if (!this.preCheck()) {
    return
  }
  // if (this.connection) {
  //   showHUD("on output")
  //   return
  // }
  // if (this.notShow && !this.called) {
  //   // showHUD("not show")
  //   return
  // }
  // if (this.addonController.config.source === "Built-in") {
  //   let usage = getUsage()
  //   if (usage.usage >= usage.limit) {
  //     showHUD("Access limited")
  //     return
  //   }else{
  //     usage.usage = usage.usage+1
  //     // showHUD("usage:"+usage.usage)
  //     setLocalDataByKey(usage,'MNChatglm_usage')
  //   }
  //   if (this.addonController.usageButton) {
  //     this.addonController.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
  //   }
  // }
  await this.delay(delay)
  let currentFrame = this.view.frame
  currentFrame.height = 120
  this.view.frame = currentFrame
  this.currentFrame = currentFrame
  await this.beginNotification()
  this.question = question
  this.apikey = config.apikey
} catch (error) {
  showHUD(error)
}
try {
  this.history = this.history.concat(question)
  var modelNames
  let model
  switch (this.addonController.config.source) {
    case "ChatGLM":
      modelNames = getModelNames("ChatGLM")
      model = modelNames[this.config.chatglmModel]
      this.initRequestForChatGLM(this.config.apikey,model,temperature)

      break;
    case "ChatGPT":
      modelNames = getModelNames("ChatGPT")
      let apikey = this.addonController.config.openaiKey
      let url = this.addonController.config.url+`/v1/chat/completions`
      model = modelNames[this.config.model]
      this.initRequestForChatGPT(apikey, url,model,temperature)
      break;
    case "Built-in":
      let keyInfo = this.addonController.keys["key"+this.addonController.config.tunnel]
      let key = getRandomElement(keyInfo.keys)
      // showHUD(key)
      // copy(JSON.stringify(key))
      if (key === "") {
        showHUD("empty key!")
        return
      }
      if (keyInfo.model === "glm-4") {
        // showHUD(JSON.stringify(key.key))
        this.initRequestForChatGLM(key,"glm-4",temperature)
      }else{
        this.initRequestForChatGPT(key, keyInfo.url,keyInfo.model,temperature)
      }
    default:
      break;
  }
} catch (error) {
  showHUD(error)
}
  // })
  
};

/**
 * 
 * @param {*} question 
 * @param {*} temperature 
 * @param {*} reask 
 * @this {notificationController}
 */
notificationController.prototype.continueAsk = function(question,temperature=0.8) {
  // Application.sharedInstance().showHUD(url, this.view.window, 2);
  // showHUD("delay:"+this.config.delay)
  let config = this.addonController.config
  if (this.notShow && !this.called) {
    // showHUD("not show")
    return
  }
  if (this.connection) {
    showHUD("on output")
    return
  }
  this.question = question
  this.apikey = config.apikey
  // this.history = this.history.concat(question)
  this.history.push({role: "user", content: question})
  // copy(JSON.stringify(this.history))
  var modelNames
  let model
  switch (this.addonController.config.source) {
    case "ChatGLM":
      modelNames = getModelNames("ChatGLM")
      model = modelNames[this.config.chatglmModel]
      this.initRequestForChatGLM(config.apikey,model,temperature)
      // this.initRequestForChatGPT(key.key, key.url,"gpt-3.5-turbo-1106",temperature)

      break;
    case "ChatGPT":
      modelNames = getModelNames("ChatGPT")
      let apikey = this.addonController.config.openaiKey
      let url = this.addonController.config.url+`/v1/chat/completions`
      model = modelNames[this.config.model]
      // showHUD(apikey)
      this.initRequestForChatGPT(apikey, url,model,temperature)
      break;
    case "Built-in":
      let keyInfo = this.addonController.keys["key"+this.addonController.config.tunnel]
      let key = getRandomElement(keyInfo.keys)
      // showHUD(key)
      // copy(JSON.stringify(key))
      if (key === "") {
        showHUD("empty key!")
        return
      }
      if (keyInfo.model === "glm-4") {
        // showHUD(JSON.stringify(key.key))
        this.initRequestForChatGLM(key,"glm-4",temperature)
      }else{
        this.initRequestForChatGPT(key, keyInfo.url,keyInfo.model,temperature)
      }
    default:
      break;
  }
};
/**
 * @this {notificationController}
 */
notificationController.prototype.finish = function() {
try {
  

  if (this.markdown) {
    this.history.push({role:"assistant",content:this.response})
  }else{
    this.history.push({role:"assistant",content:this[this.targetTextview].text})
  }
  this.query = undefined
  this.connection.cancel()
  delete this.connection
  // showHUD("delete")
  this.called = false
  // this.openChatView()
  if (this.onChat || !this.autoHide) {
    return
  }
  // let controller = this
  // this.notifyTimer = NSTimer.scheduledTimerWithTimeInterval(10, false, async function () {
  //   controller.hide()
  //   controller.notifyTimer.invalidate()
  //   controller.webviewResponse.loadHTMLStringBaseURL(html("..."))
  //   this.sizeHeight = parseInt(await self.runJavaScript(`document.body.scrollHeight`))
  // })
} catch (error) {
  showHUD(error)
}
}

notificationController.prototype.init = function () {
  // /**
  //  * @type {chatglmController}
  //  */
  // let ctr = this
  // showHUD("message")
  this.gobackImage = getImage(this.mainPath + `/goback.png`)
  this.homeImage = getImage(this.mainPath + `/home.png`)
  this.goforwardImage = getImage(this.mainPath + `/goforward.png`)
  this.reloadImage = getImage(this.mainPath + `/reload.png`)
  this.stopImage = getImage(this.mainPath + `/stop.png`)
  this.screenImage = getImage(this.mainPath + `/screen.png`)
  this.bigbangImage = getImage(this.mainPath + `/bigbang.png`)
  this.copyImage = getImage(this.mainPath + `/copy.png`)
  this.titleImage = getImage(this.mainPath + `/title.png`)
  this.tagImage = getImage(this.mainPath + `/tag.png`)
  this.commentImage = getImage(this.mainPath + `/comment.png`)
  this.aiImage = getImage(this.mainPath + `/ai.png`, 3)
  this.aiLinkImage = getImage(this.mainPath + `/aiLink.png`)
  this.chatImage = getImage(this.mainPath + `/chat.png`)
  this.sendImage = getImage(this.mainPath + `/send.png`)
  this.lockImage = getImage(this.mainPath + `/lock.png`)
  this.unlockImage = getImage(this.mainPath + `/unlock.png`)



}
notificationController.prototype.changeButtonOpacity = function(opacity) {
    this.toolbar.layer.opacity = opacity
}
/**
 * @this {notificationController}
 */
notificationController.prototype.setChatLayout = function () {
  try {
    
  let viewFrame = this.chatView.frame
  this.chatToolbar.frame = genFrame(0, viewFrame.height-30, viewFrame.width, viewFrame.height)
  this.userInput.frame = genFrame(0,viewFrame.height-85, viewFrame.width-50, 50)
  this.sendButton.frame = genFrame(viewFrame.width-45,viewFrame.height-85, 45, 50)
  this.scrollView.frame = genFrame(0, 0, viewFrame.width, viewFrame.height-90)
  let size = this.assistant0.sizeThatFits({width:viewFrame.width-10,height:1000})
  this.assistant0.frame = genFrame(5,5, viewFrame.width-10, size.height)
  // showHUD("size:"+size.height)
  let initY = size.height+10
  if (this["user"+this.round]) {
    let userSize = this["user"+this.round].sizeThatFits({width:viewFrame.width-10,height:1000})
    let assitSize = this["assistant"+this.round].sizeThatFits({width:viewFrame.width-10,height:1000})
    if (this.preRound == this.round && assitSize.height == this.preHeight) {
      return
    }
    let preFrame = this["assistant"+(this.round-1)].frame
    initY = preFrame.y+preFrame.height+5
    this["user"+this.round].frame = genFrame(5,initY, viewFrame.width-10, userSize.height)
    initY = initY+userSize.height+5
    this["assistant"+this.round].frame = genFrame(5,initY, viewFrame.width-10, assitSize.height)
    initY = initY+assitSize.height+5
    this.preHeight = assitSize.height
  }
  this.preRound = this.round
  this.scrollView.contentSize = {width:400,height:initY+5}
  if (initY > viewFrame.height-95) {
    this.scrollView.setContentOffsetAnimated({x:0,y:initY-viewFrame.height+95},true)
  }
  switch (this.addonController.config.notifyLoc) {
    case 0:
      // showHUD("left")
      this.aiButton.frame = genFrame(-45,0,40,40)
      this.closeChatButton.frame = genFrame(viewFrame.width-30, 0, 30, 30)
      this.chatToken.frame = genFrame(viewFrame.width-135, 0, 100, 30)
      this.chatLocation.frame = genFrame(0,0,55,30)
      break;
    case 1:
      // showHUD("right")
      this.aiButton.frame = genFrame(viewFrame.width+5,0,40,40)
      this.chatLocation.frame = genFrame(viewFrame.width-55,0,55,30)
      this.chatToken.frame = genFrame(35, 0, 100, 30)
      this.closeChatButton.frame = genFrame(0, 0, 30, 30)
      break;
    default:
      break;
  }
  // showHUD(JSON.stringify(this.view.frame))
  } catch (error) {
    showHUD(error)
  }
}

/**
 * @this {notificationController}
 */
notificationController.prototype.setNotiLayout = async function () {
  let sizeHeight;
  if (this.markdown) {
    // sizeHeight = this.webviewResponse.scrollView.contentSize.height
    sizeHeight = this.sizeHeight
    // showHUD("message:"+sizeHeight)
  }else{
    sizeHeight = this[this.targetTextview].sizeThatFits({width:400,height:1000}).height+5
  }
    // this.size.push({message:'message1',current:currentFrame.height,size:sizeHeight,study:studyHeight})
  // showHUD(JSON.stringify(value))
  // this.webviewResponse.evaluateJavaScript(`document.documentElement.scrollHeight`, (res)=>{
    // showHUD(res)
  // })
  
    // showHUD("height:"+this.preHeight+",height:"+sizeHeight)

      // this.webviewResponse.frame = genFrame(0, 0, 400, sizeHeight)
  // if (sizeHeight <= this.preHeight ) {

  //   // copy("preheight:"+this.preHeight+",height:"+sizeHeight)
  //   // showHUD("preheight:"+this.preHeight+",height:"+sizeHeight)
  //   return
  // }
  // this.preHeight = sizeHeight
  // showHUD("message")

  let currentFrame = this.view.frame
  let studyHeight = studyController().view.frame.height
  // copy(JSON.stringify(this.size))
  if (sizeHeight+35<120) {
    currentFrame.height = 120
      // showHUD('message3')

    this.size.push({message:'message3',current:currentFrame.height,size:sizeHeight,study:studyHeight})
  }else{
    if (sizeHeight+35 > currentFrame.height && sizeHeight-currentFrame.height < 50) {
      currentFrame.height = sizeHeight+35
    }
    if ((currentFrame.y+sizeHeight+30)>studyHeight) {
      // showHUD('message2')
    this.size.push({message:'message2',current:currentFrame.height,size:sizeHeight,study:studyHeight})
      this.scrollToBottom = true
      currentFrame.height = studyHeight-currentFrame.y
      this.autoHide = false
      if (this.markdown) {
        this.webviewResponse.frame = genFrame(0, 0, 400, currentFrame.height-35)
      }else{
        this.textviewResponse.frame = genFrame(0, 0, 400, sizeHeight)
      }
      // this.webviewResponse.frame = genFrame(0, 0, 400, sizeHeight+30)
      // this.notiScroll.contentSize = {width:400,height:sizeHeight}
      // this.notiScroll.setContentOffsetAnimated({x:0,y:sizeHeight-this.notiScroll.frame.height+30},true)
    }else{
      currentFrame.height = sizeHeight+35
      // showHUD('message1')
      this.size.push({message:'message1',current:currentFrame.height,size:sizeHeight,study:studyHeight})
      this.webviewResponse.frame = genFrame(0, 0, 400, sizeHeight)
    }
  }

  this.view.frame = currentFrame
  this.currentFrame = currentFrame
  // copy(JSON.stringify(this.size))
  // showHUD(JSON.stringify(this.size))
}
notificationController.prototype.createButton = function (buttonName,targetAction,superview) {
    this[buttonName] = UIButton.buttonWithType(0);
    this[buttonName].autoresizingMask = (1 << 0 | 1 << 3);
    this[buttonName].setTitleColorForState(UIColor.whiteColor(),0);
    this[buttonName].setTitleColorForState(this.highlightColor, 1);
    this[buttonName].backgroundColor = hexColorAlpha("#9bb2d6",0.8)
    this[buttonName].layer.cornerRadius = 8;
    this[buttonName].layer.masksToBounds = true;
    this[buttonName].titleLabel.font = UIFont.systemFontOfSize(16);

    if (targetAction) {
      this[buttonName].addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    if (superview) {
      this[superview].addSubview(this[buttonName])
    }else{
      this.view.addSubview(this[buttonName]);
    }
}
/**
 * @this {notificationController}
 */
notificationController.prototype.creatTextView = function (viewName,superview="view",color="#ffffff",alpha=0.8) {
  this[viewName] = UITextView.new()
  // this[viewName] = new UITextView(genFrame(0, 0, 400, 1000))
  this[viewName].font = UIFont.systemFontOfSize(17);
  this[viewName].layer.cornerRadius = 8
  this[viewName].backgroundColor = hexColorAlpha(color,alpha)
  this[viewName].textColor = UIColor.blackColor()
  this[viewName].delegate = this
  this[viewName].editable = true
  this[viewName].scrollEnabled = false
  this[viewName].bounces = false
  this[viewName].layer.borderWidth = 4

  this[superview].addSubview(this[viewName])
  // this[viewName].frame = genFrame(5,5,390,100)
}

notificationController.prototype.hideAllButton = function (frame) {
  this.toolbar.hidden = true
}
notificationController.prototype.showAllButton = function (frame) {
  this.toolbar.hidden = false
}
notificationController.prototype.show = function (notifyLoc) {
try {
  
  let studyFrame = studyController().view.frame
  let height = this.onChat?studyFrame.height-50:120
  this.notifyLoc = notifyLoc
  switch (this.notifyLoc) {
    case 0:
      this.currentFrame.x = 50
      this.view.frame = {x:-300,y:50,width:400,height:height}
      break;
    case 1:
      this.currentFrame.x = studyFrame.width-450
      this.view.frame = {x:studyFrame.width,y:50,width:400,height:height}
      break;
    default:
      break;
  }
  // showHUD(JSON.stringify(this.view.frame))
  let preFrame = this.currentFrame
  preFrame.width = 400
  let preOpacity = this.view.layer.opacity
  this.view.layer.opacity = 0.2
  // if (frame) {
  //   this.view.frame = frame
  //   this.currentFrame = frame
  // }
  this.view.hidden = false
    this.setLayout()
  this.hideAllButton()

  UIView.animateWithDurationAnimationsCompletion(0.3,()=>{
    this.view.layer.opacity = preOpacity
    this.view.frame = preFrame
    // this.currentFrame = preFrame
    this.setLayout()
  },
  ()=>{
    this.view.layer.borderWidth = 0
    this.showAllButton()
  })
} catch (error) {
  showHUD(message)
}
}
/**
 * @this {notificationController}
 */
notificationController.prototype.hide = async function () {
  let studyFrame = this.appInstance.studyController(this.view.window).view.bounds
  if (this.connection) {
    this.connection.cancel()
    delete this.connection
  }
  switch (this.notifyLoc) {
    case 0:
      this.currentFrame.x = -this.currentFrame.width
      // this.view.frame = {x:-300,y:10,width:300,height:120}
      break;
    case 1:
      this.currentFrame.x = studyFrame.width
      // this.view.frame = {x:studyFrame.width,y:10,width:300,height:120}
      break;
    default:
      break;
  }
  let preFrame = this.currentFrame
  let preOpacity = this.view.layer.opacity
  let preCustom = this.custom
  // let preFrame = this.view.frame
  this.hideAllButton()
  this.custom = false
  return new Promise((resolve, reject) => {

  UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
    this.view.layer.opacity = 0.2
    this.view.frame = preFrame
    // if (frame) {
    //   this.view.frame = frame
    //   this.currentFrame = frame
    // }
    // this.view.frame = {x:preFrame.x+preFrame.width*0.1,y:preFrame.y+preFrame.height*0.1,width:preFrame.width*0.8,height:preFrame.height*0.8}
    // this.currentFrame = {x:preFrame.x+preFrame.width*0.1,y:preFrame.y+preFrame.height*0.1,width:preFrame.width*0.8,height:preFrame.height*0.8}
  },
  ()=>{
    this.view.hidden = true;
    this.view.layer.opacity = preOpacity      
    this.view.frame = preFrame
    // this.currentFrame = preFrame
    this.custom = preCustom
    resolve()

    // this.view.frame = preFrame
    // this.currentFrame = preFrame
  })
      
  })
}

/**
 * @this {notificationController}
 */
notificationController.prototype.setLayout = function () {
try {
  

  var viewFrame = this.toolbar.bounds;
  var width    = viewFrame.width
  var height   = viewFrame.height
  viewFrame.height = viewFrame.height-30
  switch (this.notifyLoc) {
    case 0:
      this.aiButton.frame = genFrame(-45,0,40,40)
      this.screenButton.frame = genFrame(width-30,0,30,30)
      this.bigbangButton.frame = genFrame(width-65,0,30,30)
      this.commentButton.frame = genFrame(width-100,0,30,30)
      this.titleButton.frame = genFrame(width-135,0,30,30)
      this.copyButton.frame = genFrame(width-170,0,30,30)
      this.aiLinkButton.frame = genFrame(width-205,0,30,30)
      this.reloadButton.frame = genFrame(width-240,0,30,30)
      this.chatButton.frame = genFrame(width-275,0,30,30)
      this.locationButton.frame = genFrame(90,0,30,30)
      this.promptButton.frame = genFrame(0,0,85,30)

      break;
    case 1:
      this.aiButton.frame = genFrame(width+5,0,40,40)
      this.screenButton.frame = genFrame(0,0,30,30)
      this.bigbangButton.frame = genFrame(35,0,30,30)
      this.commentButton.frame = genFrame(70,0,30,30)
      this.titleButton.frame = genFrame(105,0,30,30)
      this.copyButton.frame = genFrame(140,0,30,30)
      this.aiLinkButton.frame = genFrame(175,0,30,30)
      this.reloadButton.frame = genFrame(210,0,30,30)
      this.chatButton.frame = genFrame(245,0,30,30)
      this.locationButton.frame = genFrame(viewFrame.width-120,0,30,30)
      this.promptButton.frame = genFrame(viewFrame.width-85,0,90,30)
      break;
    default:
      break;
  }
} catch (error) {
  showHUD(error)
}
}
/** @this {notificationController} */
notificationController.prototype.beginNotification = async function () {

    await this.setResponseText("I'm thinking...")
    this.locationButton.setTitleForState(this.addonController.config.notifyLoc?' R ':' L ',0)
    try {
    this.promptButton.setTitleForState(this.addonController.prompts[this.currentPrompt].title ,0)
    } catch (error) {
      showHUD(error)
    }
    if (this.view.hidden || this.notifyLoc !== this.config.notifyLoc) {
      this.show(this.config.notifyLoc)
    }

    this.appInstance.studyController(this.view.window).view.bringSubviewToFront(this.view)
    if (this.notifyTimer) {
      this.notifyTimer.invalidate()
    }
  }

/** @this {notificationController} */
notificationController.prototype.getTextForAction = async function (params) {
  if (this.markdown) {
    let selectedText = await this.runJavaScript("window.getSelection().toString()")
    if (selectedText.trim() !== "") {
      return selectedText.trim()
    }
    return this.response.trim()
  }
  let selectedRange = this.textviewResponse.selectedRange
  let text = this.textviewResponse.text
  if (selectedRange.length) {
    let selectedText = text.slice(selectedRange.location,selectedRange.location+selectedRange.length)
    return selectedText.trim()
  }else{
    return text.trim()
  }
}

/**
 * @this {notificationController}
 */
notificationController.prototype.initRequest = function (url,options) {
  const request = NSMutableURLRequest.requestWithURL(genNSURL(url))
  request.setHTTPMethod(options.method ?? "GET")
  request.setTimeoutInterval(options.timeout ?? 10)
  const headers = {
    "User-Agent":
      "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15",
    "Content-Type": "application/json",
    Accept: "application/json"
  }
  request.setAllHTTPHeaderFields({
    ...headers,
    ...(options.headers ?? {})
  })
  if (options.search) {
    request.setURL(
      genNSURL(
        `${url.trim()}?${Object.entries(options.search).reduce((acc, cur) => {
          const [key, value] = cur
          return `${acc ? acc + "&" : ""}${key}=${encodeURIComponent(value)}`
        }, "")}`
      )
    )
  } else if (options.body) {
    request.setHTTPBody(NSData.dataWithStringEncoding(options.body, 4))
  } else if (options.form) {
    request.setHTTPBody(
      NSData.dataWithStringEncoding(
        Object.entries(options.form).reduce((acc, cur) => {
          const [key, value] = cur
          return `${acc ? acc + "&" : ""}${key}=${encodeURIComponent(value)}`
        }, ""),
        4
      )
    )
  } else if (options.json) {
    request.setHTTPBody(
      NSJSONSerialization.dataWithJSONObjectOptions(
        options.json,
        1
      )
    )
  }
  return request
}
notificationController.prototype.initRequestForChatGPT = function (apikey,url,model,temperature) {
  if (apikey.trim() === "") {
    showHUD("No apikey!")
    return
  }
  const headers = {
    "Content-Type": "application/json",
    Authorization: "Bearer "+apikey
  }
  let body = {
    "model":model,
    "messages":this.history,
    "temperature":temperature,
    "stream":true
  }
  const request = this.initRequest(url, {
      method: "POST",
      headers: headers,
      timeout: 60,
      json: body
    })
  this.currentTime = Date.now()
  this.connection = NSURLConnection.connectionWithRequestDelegate(request,this)

}
/** 
 * @this {notificationController}
 */
notificationController.prototype.initRequestForChatGLM = function (apikey,model,temperature) {
  if (apikey.trim() === "") {
    showHUD("No apikey!")
    return
  }
  // copy(apikey)
  let final_sign = getAuthorization(apikey)    
  const headers = {
    "Content-Type": "application/json",
    Authorization: final_sign
  }
  // showHUD(JSON.stringify(this.history))
  // copy(JSON.stringify(this.history))

  let body = {
    "model":model,
    "messages":this.history,
    "temperature":temperature,
    "stream":true
  }
  const request = this.initRequest("https://open.bigmodel.cn/api/paas/v4/chat/completions", {
      method: "POST",
      headers: headers,
      timeout: 60,
      json: body
    })
  this.currentTime = Date.now()
  this.connection = NSURLConnection.connectionWithRequestDelegate(request,this)
  // let body = {
  //     model:'glm-3-turbo',
  //     messages: [
  //       {"role": "user", "content": "你好"},
  //       {"role": "assistant", "content": "我是人工智能助手"},
  //       {"role": "user", "content": "你叫什么名字"},
  //       {"role": "assistant", "content": "我叫chatGLM"},
  //       {"role": "user", "content": "你都可以做些什么事"}
  //   ],
  //     stream:true,
  //     temperature:temperature
  //   }
  // let url = `https://open.bigmodel.cn/api/paas/v4/chat/completions`
  // const request = this.initRequest(url, {
  //     method: "POST",
  //     headers: headers,
  //     timeout: 60,
  //     json: body
  //   })
  // this.currentTime = Date.now()
  // this.connection = NSURLConnection.connectionWithRequestDelegate(request,this)
}

notificationController.prototype.getResponseForChatGLM = function (response) {
  var checkMessageNumber = this.textString.split("event:add")
  let messageBumber = checkMessageNumber.length
  if (messageBumber>=2) {
    var items = checkMessageNumber[messageBumber-1].split("\n")
    let data
    if (items.length !== 5) {
      let dataItems = items.filter(item=>/data:/.test(item))
      // showHUD(dataItems)
      data = dataItems.map(item=>item.split("data:")[1]).join("\n")
    }else{
      data = items[2].split("data:")[1]
    }
    // self.response = self.response+data
    // self.allText = self.allText+textString
    let diff = data.length - this[this.targetTextview].text.length
    if (diff > 30 || diff < 0) {
      return undefined
    }
    return data.trim()
    // this[this.targetTextview].text = data.trim()//self.response.trim().replaceAll("   ","\n").replaceAll("  "," ")
    // self[self.targetTextview].scrollRectToVisibleAnimated(genFrame(0, size.height-currentFrame.height, 400, currentFrame.height-30),false)
  }else{
    return undefined
  }
}
/** 
 * @param {string} response 
 * @this {notificationController}
 */
notificationController.prototype.getResponseForChatGPT = function (response) {
try {
  this.originalText = this.originalText+response
  let res = this.originalText.split("data:")
  res.shift()
  let last = res.pop()
  let length = res.length
  this.response = res.map(r=>JSON.parse(r).choices[0].delta.content).join("")
  // if (/\[DONE\]/.test(last)) {
    // this.response = this.response+tem
    // copy(response)
    // copy(tem)
  return
    // return this.response.trimStart()
  // }
  // let tem = this.originalText.split("data:").slice(1).map(r=>JSON.parse(r).choices[0].delta.content).join("")
  // this.response = this.response+tem
  // copy(tem)
  // return tem
  // return this.response.trimStart()
} catch (error) {
  showHUD(error)
  copy(response)
  return
}
}

notificationController.prototype.getTokensForChatGLM = function (response) {


}
notificationController.prototype.openChatView = function (params) {
    // if (this.connection) {
    //   showHUD("Wait...")
    //   return
    // }
    // this.round = 0
    // if (this.notifyTimer) {
    //   this.notifyTimer.invalidate()
    // }
    // this.notificationView.hidden = true
    // this.onChat = true
    this.chatView = new UIView(this.view.bounds)
    this.chatView.layer.cornerRadius = 8
    this.chatView.backgroundColor = hexColorAlpha("#ffffff",0.0)
    this.view.addSubview(this.chatView)
}
notificationController.prototype.delay = async function (seconds) {
  return new Promise((resolve, reject) => {
    NSTimer.scheduledTimerWithTimeInterval(seconds, false, function () {
      resolve()
    })
  })
}
notificationController.prototype.createTextviewResponse  = function () {
  this.textviewResponse = UITextView.new()
  this.textviewResponse.font = UIFont.systemFontOfSize(16);
  this.textviewResponse.layer.cornerRadius = 8
  this.textviewResponse.backgroundColor = hexColorAlpha("#ffffff",0.8)
  this.textviewResponse.textColor = UIColor.blackColor()
  this.textviewResponse.delegate = this
  this.textviewResponse.contentSize = {width:400,height:120}
  this.textviewResponse.scrollEnabled = false
  this.textviewResponse.text = `Loading...`
}
notificationController.prototype.createWebviewResponse = function () {
  try {
    

  this.webviewResponse = new UIWebView(this.view.bounds);
  // NSUserDefaults.standardUserDefaults().setObjectForKey('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15',"UserAgent")
  //  Application.sharedInstance().showHUD("error", this.view.window, 2);
  this.webviewResponse.backgroundColor = UIColor.whiteColor();
  this.webviewResponse.scalesPageToFit = true;
  this.webviewResponse.autoresizingMask = (1 << 1 | 1 << 4);
  this.webviewResponse.delegate = this;
  // this.webviewResponse.setValueForKey("Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15","User-Agent")
  this.webviewResponse.scrollView.delegate = this;
  this.webviewResponse.layer.cornerRadius = 8;
  this.webviewResponse.layer.masksToBounds = true;
  this.webviewResponse.layer.borderColor = hexColorAlpha("#9bb2d6",0.8);
  this.webviewResponse.layer.borderWidth = 0
  this.webviewResponse.loadHTMLStringBaseURL(html(`Loading...`))
    } catch (error) {
    showHUD(error)
  }
}
/** @this {notificationController} */
notificationController.prototype.runJavaScript = async function(script) {
  // if(!this.webviewResponse || !this.webviewResponse.window)return;
  return new Promise((resolve, reject) => {
      this.webviewResponse.evaluateJavaScript(script,(result) => {resolve(result)});
  })
};
/** @this {notificationController} */
notificationController.prototype.getSharedKey = function (params) {
  let tunnel = this.addonController.config.tunnel
  let keys
  let url
  switch (tunnel) {
    case 0:
      keys = this.addonController.keys.aivesa
      url = "https://api.freegpt.icu/v1/chat/completions"
      break;
    case 1:
      keys = this.addonController.keys.keyLong
      url = "https://api.chatanywhere.tech/v1/chat/completions"
      break;
    case 2:
      return this.addonController.keys.chatglm
    case 3:
      return {key:this.addonController.keys.oneChat,url:"https://sapi.onechat.fun/v1/chat/completions"}
    default:
      break;
  }
  if (!keys) {
    showHUD("empty")
  }
  let key = getRandomElement(keys)
  return {key:key,url:url}
}
/** @this {notificationController} */
notificationController.prototype.setResponseText = async function (response) {
  if (this.markdown && !this.onChat) {
    try {
    // copy(marked.parse(this.response))
    // this.webviewResponse.loadHTMLStringBaseURL(marked.parse(this.response))
    // copy(marked.parse(response))
    this.webviewResponse.loadHTMLStringBaseURL(html(marked.parse(response),this.scrollToBottom))
    this.sizeHeight = parseInt(await this.runJavaScript(`document.body.scrollHeight`))
    // let scrollview = this.webviewResponse.scrollView.contentSize
    // showHUD(JSON.stringify(scrollview))
    } catch (error) {

      showHUD(error)
    }
  }else{
    this[this.targetTextview].text = this.response
  }
}
/**
 * @type {UIView}
 */
notificationController.prototype.view