function genNSURL(url) {
  return NSURL.URLWithString(url)
}



/**
 * Ported version of Node Fetch, but with reduced features.
 */


function strCode(str) {  //获取字符串的字节数
    var count = 0;  //初始化字节数递加变量并获取字符串参数的字符个数
    var cn = [8211, 8212, 8216, 8217, 8220, 8221, 8230, 12289, 12290, 12296, 12297, 12298, 12299, 12300, 12301, 12302, 12303, 12304, 12305, 12308, 12309, 65281, 65288, 65289, 65292, 65294, 65306, 65307, 65311]
    var half = [32, 33, 34, 35, 36, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 58, 59, 60, 61, 62, 63, 64, 91, 92, 93, 94, 95, 96, 123, 124, 125, 126,105,108,8211]
    if (str) {  //如果存在字符串，则执行
        len = str.length; 
        for (var i = 0; i < len; i++) {  //遍历字符串，枚举每个字符
          let charCode = str.charCodeAt(i)
            if (charCode>=65 && charCode<=90) {
              count += 1.5;  //大写
            } else if (half.includes(charCode)) {
              count +=0.45
            } else if (cn.includes(charCode)) {
              count +=0.8
            }else if (charCode > 255) {  //字符编码大于255，说明是双字节字符(即是中文)
                count += 2;  //则累加2个
            }else{
                count++;  //否则递加一次
            }
        }
        return count;  //返回字节数
    } else {
        return 0;  //如果参数为空，则返回0个
    }
}

function getSplitLine() {
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let readerFrame = Application.sharedInstance().studyController(this.window).readerController.view.frame
    let hidden = Application.sharedInstance().studyController(this.window).readerController.view.hidden//true代表脑图全屏
    let rightMode = Application.sharedInstance().studyController(this.window).rightMapMode
    let fullWindow = readerFrame.width == studyFrame.width
    if (hidden || fullWindow) {
      let splitLine = studyFrame.width*0.5
      return splitLine
    }
    if (rightMode) {
      let splitLine = readerFrame.x+readerFrame.width
      return splitLine
    }else{
      let splitLine = readerFrame.x
      return splitLine
    }
  }

function undoGroupingWithRefresh(notebookid,f){
  UndoManager.sharedInstance().undoGrouping(
    String(Date.now()),
    notebookid,
    f
  )
  Application.sharedInstance().refreshAfterDBChanged(notebookid)
}

function hexColorAlpha(hex,alpha=1.0) {
  let color = UIColor.colorWithHexString(hex)
  return alpha!==undefined?color.colorWithAlphaComponent(alpha):color
}

function genFrame(x,y,width,height) {
  return {x:x,y:y,width:width,height:height}
}

function getOrderText(order) {
  if (order[0] == 4) {
    return 'Order: (Title) + (Excerpt → Comment)'
  }
  let orderNumber = `${order[0]}${order[1]}${order[2]}`
  switch (orderNumber) {
    case "123":
      return 'Order: Title → Excerpt → Comment'
    case "132":
      return 'Order: Title → Comment → Excerpt'
    case "213":
      return 'Order: Excerpt → Title → Comment'
    case "231":
      return 'Order: Excerpt → Comment → Title'
    case "312":
      return 'Order: Comment → Title → Excerpt'
    case "321":
      return 'Order: Comment → Excerpt → Title'
    default:
      return "123";
  }
}

function shouldPrevent(currentURL,requestURL,type) {
  let firstCheck = Application.sharedInstance().osType === 0 && (type===0 || /^https:\/\/m.inftab.com/.test(currentURL))
  if (firstCheck) {
    let blacklist = ["^https?://www.bilibili.com","^https?://m.bilibili.com","^https?://space.bilibili.com","^https?://t.bilibili.com","^https?://www.wolai.com","^https?://flowus.com","^https?://www.notion.so"]
    if (blacklist.some(url=>RegExp(url).test(requestURL))) {
      return true
    }
  }
  return false
}

function showHUD(message,duration=2) {
  let focusWindow = Application.sharedInstance().focusWindow
  Application.sharedInstance().showHUD(message,focusWindow,2)
}


function postNotification(name,userInfo) {
  let focusWindow = Application.sharedInstance().focusWindow
  NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo(name, focusWindow, userInfo)
  
}

function getNoteById(noteid) {
  let note = Database.sharedInstance().getNoteById(noteid)
  return note
}

function getImage(path,scale=2) {
  return UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(path), scale)
}

function setLocalDataByKey(value,key) {
  NSUserDefaults.standardUserDefaults().setObjectForKey(value,key)
  NSUserDefaults.standardUserDefaults().synchronize()
}

function getLocalDataByKey(key) {
  return NSUserDefaults.standardUserDefaults().objectForKey(key)
}

function getLocalDataByKeyDefault(key,defaultValue) {
  let value = NSUserDefaults.standardUserDefaults().objectForKey(key)
  if (value === undefined) {
    NSUserDefaults.standardUserDefaults().setObjectForKey(defaultValue,key)
    return defaultValue
  }
  return value
}

function addObserver(object,target,notification) {
  NSNotificationCenter.defaultCenter().addObserverSelectorName(object, target, notification);
}
function removeObservers(object,notifications) {
  notifications.forEach(notification=>{
    NSNotificationCenter.defaultCenter().removeObserverName(object, notification);
  })
}

function getPopoverAndPresent(sender,commandTable,width=100) {
  var menuController = MenuController.new();
  menuController.commandTable = commandTable
  menuController.rowHeight = 35;
  menuController.preferredContentSize = {
    width: width,
    height: menuController.rowHeight * menuController.commandTable.length
  };
  var popoverController = new UIPopoverController(menuController);
  let focusWindow = Application.sharedInstance().focusWindow
  var studyController = Application.sharedInstance().studyController(focusWindow);
  var r = sender.convertRectToView(sender.bounds,studyController.view);
  popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  return popoverController
}
function copy(text) {
  UIPasteboard.generalPasteboard().string = text
}
function countWords(str) {
    const chinese = Array.from(str)
        .filter(ch => /[\u4e00-\u9fa5]/.test(ch))
        .length
    
    const english = Array.from(str)
        .map(ch => /[a-zA-Z0-9\s]/.test(ch) ? ch : ' ')
        .join('').split(/\s+/).filter(s => s)
        .length

    return chinese + english
}
function studyController() {
  let focusWindow = Application.sharedInstance().focusWindow
  return Application.sharedInstance().studyController(focusWindow)
}
function sum(array) {
  let sum = 0
  for (let i = 0; i < array.length; i++) {
    sum = sum+array[i]
  }
  return sum
}

function getRandomElement(arr) {
  if (arr.length === 1) {
    return arr[0]
  }
  if (arr && arr.length) {
    const randomIndex = Math.floor(Math.random() * arr.length);
    return arr[randomIndex];
  }
  return ""; // 或者抛出一个错误，如果数组为空或者未定义
}

function getToday() {
  // 创建一个新的Date对象，默认情况下它会包含当前日期和时间
  const today = new Date();

  // 获取日
  const day = today.getDate();
  // showHUD(day)
  return day
}

function getUsage() {
  let default_usage = {limit:100,day:getToday(),usage:0}
  let usage = getLocalDataByKeyDefault('MNChatglm_usage',default_usage)
  let today = getToday()
  usage.limit = 100
  if (today !== usage.day) {
    usage.usage = 0
    usage.day = today
  }
  return usage
}

function getConfig() {
  let defaultPrompts = {
      Translate:                      {title: "翻译",context:"请翻译下面这段话：{{context}}"},
      Keyword:                        {title: "关键词",context:"请为下面这段话提取关键词：{{context}}"},
      Title:                          {title: "标题",context:"请为下面这段话生成标题：{{context}}"}
  }
  let defaultConfig = {
    searchOrder: [2,1,3],
    autoAction: false,
    onSelection: true,
    onNote: true,
    onNewExcerpt: true,
    notifyLoc: 0,
    toolbar: true,
    model: 0,
    chatglmModel:0,
    promptNames: Object.keys(defaultPrompts),
    currentPrompt: Object.keys(defaultPrompts)[0],
    apikey: "",
    modelOnReAsk: -1,
    source: "ChatGLM",
    url: "https://api.openai.com",
    openaiKey: "",
    tunnel:0
  }
  let config = getLocalDataByKeyDefault('MNChatglm_config',defaultConfig)
  if (!config.source) {
    config.source = "ChatGLM"
    config.url = "https://api.openai.com"
    config.openaiKey = ""
    config.tunnel = 0
  }
  if(config.chatglmModel === undefined){
    config.chatglmModel = 0
  }
  return config
}

function getModelNames(source) {
  switch (source) {
    case "ChatGLM":
      return ["glm-3-turbo","glm-4"]
      break;
    case "ChatGPT":
      return ["gpt-3.5-turbo","gpt-3.5-turbo-1106","gpt-3.5-turbo-16k","gpt-4","gpt-4-32k","gpt-4-1106-preview","glm-4"]
    default:
      break;
  }
}

function html(string,scrollToBottom=false) {
  if (scrollToBottom) {
    return `<!doctype html>
<html>
<head>
  <meta charset="utf-8">
  <title>Marked.js</title>
</head>
<body>
${string}
<script>
window.scrollTo(0,document.body.scrollHeight);
</script>
</body>
</html>`
  }
return `<!doctype html>
<html>
<head>
  <meta charset="utf-8">
  <title>Marked.js</title>
</head>
<body>
${string}
<br>
</body>
</html>`
}